const _ = require('lodash');
const assert = require('assert');

class JsonLdSolr {

  setConfig(config) {
    this.config = config;
    return this.validateConfig();
  }

  validateConfig() {
    // Validate the configuration needs.
    _.each(this.config, (config) => {
      assert.strictEqual(_.isArray(config['entryPoints']), true, 'missing entryPoints in configuration');
      _.each(config, function (entryPoints) {
        assert.strictEqual(_.isObject(entryPoints['facets']), true, 'missing facets in entryPoints configuration');
        assert.strictEqual(_.isObject(entryPoints['flatten']), true, 'missing flatten in entryPoints configuration');
        assert.strictEqual(_.isObject(entryPoints['followLinks']), true, 'missing followLinks in entryPoints configuration');
      });
      return true;
    });
  }

  ensureObjArray(graphElement) {
    _.forOwn(graphElement, (ge, prop) => {
      if (!_.isArray(ge)) {
        graphElement[prop] = [ge];
      }
    });
    return graphElement;
  }

  entryPoints(entryPoints, graph) {
    _.forEach(entryPoints, (eP) => {
      let graphElement = _.filter(graph, (g) => {
        return _.find(g['@type'], (gg) => gg === eP['@type']) ? g : undefined;
      });
        this.getGraphElement(eP, graph, graphElement);
    })
  }

  getGraphElement(config, graph, graphElement){
    //TODO me!
  }
}

JsonLdSolr.config = {};

module.exports = JsonLdSolr;